
#include <18F2320.h>

//#ignore_warnings 202

#FUSES NOWDT                    //No Watch Dog Timer
#FUSES WDT128                   //Watch Dog Timer uses 1:128 Postscale
#FUSES HS//INTRC_IO                 //Internal RC Osc
#FUSES PUT                      //Power Up Timer
#FUSES NOBROWNOUT               //No brownout reset
#FUSES NOLVP                    //No low voltage prgming, B3(PIC16) or B5(PIC18) used for I/O
#fuses MCLR


#use delay(xtal=16Mhz, clock=16Mhz) 
#use rs232(baud=9600,xmit=PIN_c6,rcv=PIN_c7)
#use spi (MASTER,FORCE_HW/*,MODE=3*/,BITS=8,MSB_FIRST)	//DO=C5
//***********************************************************
//#include "M25P10A.c" 
//***********************************************************
#define CS_M25	PIN_A2
unsigned int8 SpiFlash_buffer[255];
//***********************************************************
#define	WREN	0x06
#define	WRDI	0x04
#define	RDSR	0x05
#define	WRSR	0x01
#define	READ	0x03
#define	PP	0x02
#define	SE	0xd8
//***********************************************************
void SpiFlash_WREN(void)
{
	delay_cycles(2);
	OUTPUT_low(CS_M25);
	delay_cycles(2);
	SPI_WRITE(WREN);
	OUTPUT_HIGH(CS_M25);
	delay_cycles(2);
}
//***********************************************************
unsigned int8 SpiFlash_RDSR(void)					
{
unsigned char i;
	delay_cycles(2);
	OUTPUT_LOW(CS_M25);
	delay_cycles(2);
	SPI_WRITE(RDSR);
	delay_cycles(2);
	i = SPI_READ(0xff);   		
	delay_cycles(2);
	OUTPUT_HIGH(CS_M25);
	return i;
}
//***********************************************************
void SpiFlash_READ(unsigned int32 StartAddr, unsigned int8 LengthOfData)
{
unsigned int8 i;
	delay_cycles(2);
	OUTPUT_LOW(CS_M25);
	delay_cycles(2);
	SPI_WRITE(READ);
	delay_cycles(2);
	SPI_WRITE((unsigned char)(StartAddr>>16));//addr bit [23..16]
	delay_cycles(2);
	SPI_WRITE((unsigned char)(StartAddr>>8));//addr bit [15..8]
	delay_cycles(2);
	SPI_WRITE((unsigned char)(StartAddr));//addr bit [7..0]
	delay_cycles(2);
	for (i =0 ; i<LengthOfData; i++)	//save data from [0]
	{
		SpiFlash_buffer[i] = SPI_READ(0xff);
	}
	delay_cycles(2);
	OUTPUT_HIGH(CS_M25);
	delay_cycles(2);
}
//***********************************************************
void SpiFlash_PP(unsigned int32 StartAddr, unsigned int8 LengthOfData)  					
{
unsigned int8 i;

	while((SpiFlash_RDSR())!=0);
	//while((SpiFlash_RDSR()&0xfd)!=0);

	delay_cycles(2);
	SpiFlash_WREN();	
	delay_cycles(2);
	OUTPUT_LOW(CS_M25);
	delay_cycles(2);
	SPI_WRITE(PP);		
	delay_cycles(2);
	SPI_WRITE((unsigned char)(StartAddr>>16));// [23..16]
	delay_cycles(2);
	SPI_WRITE((unsigned char)(StartAddr>>8));// [15..8]
	delay_cycles(2);
	SPI_WRITE((unsigned char)StartAddr);// [7..0]
	delay_cycles(2);
	for (i =0 ; i<LengthOfData; i++)	//send data from [0]
	{
		SPI_WRITE(SpiFlash_buffer[i]);
		//printf("%2X,",SpiFlash_buffer[i]);
	}
	delay_cycles(2);
	OUTPUT_HIGH(CS_M25);
	delay_cycles(2);
}
//************************************************************************
void main()
{
unsigned int8 i,b,a;

OUTPUT_HIGH(CS_M25);
SETUP_SPI(SPI_MASTER | SPI_CLK_DIV_64 | SPI_XMIT_L_TO_H |/**/ SPI_SCK_IDLE_HIGH);
delay_ms(50);

output_high(PIN_A1);
delay_ms(2000);
printf("Start\r\n");
/* */
memset(SpiFlash_buffer,0xf0,sizeof(SpiFlash_buffer));
SpiFlash_PP(0x000000,0xff);

b=SpiFlash_RDSR();
//delay_us(500);
printf("RDSR=%2X\r\n",b);
b=SpiFlash_RDSR();
//delay_us(500);
printf("RDSR=%2X\r\n",b);
b=SpiFlash_RDSR();
//delay_us(500);
printf("RDSR=%2X\r\n",b);
b=SpiFlash_RDSR();
printf("RDSR=%2X\r\n",b);



SpiFlash_READ(0x000000,0xff);
b=SpiFlash_RDSR();
printf("RDSR=%2X\r\n",b);
for(i=0;i<0xff;i++)
{
printf("%2X,",SpiFlash_buffer[i]);
}
printf("\r\n");

printf("\r\nkonec");
output_low(PIN_A1);
while(true);

}